from dolfin import *
import numpy

def generate_data(M):

    # Create FEM linear system
    mesh = UnitSquare(M, M)
    V = FunctionSpace(mesh, "CG", 1)
    v = TestFunction(V)
    u = TrialFunction(V)
    f = Expression("sin(x[0])")
    a = (dot(grad(v), grad(u)) + u * v) * dx
    L = v * f * dx

    A = assemble(a)
    b = assemble(L)

    xref = Vector()
    ksolver = KrylovSolver("cg", "none")
    print "Solving with DOLFIN simple Conjugate Gradient linear solver: "
    ksolver.solve(A, xref, b)

    return (A.array(),
            b.array(),
            xref.array())
