from bisect import *
from pylab import *
import unittest
import fixedpoint as module

# Utility functions
def near(val, ref, tol):
    return abs(val - ref) <= tol

# Utility functions
def near_array(val, ref, tol):
    print "val: ", val
    print "ref: ", ref
    return norm(val - ref, ord=inf) <= tol

class Test_Module3(unittest.TestCase):

    # Test square_equation()
    def test_FixedpointNewton_Question1_Subquestion1(self):
        val1 = module.square_equation()
        ref1a = 1.0
        ref1b = 3.0
        tol1 = 1.0e-4

        message = "Root too far from reference value. See unittest/moduletest.py for details. received: %f reference: %f correct number of decimals required: %f"

        self.assertTrue(near(val1, ref1a, tol1) or
                        near(val1, ref1b, tol1))

    # Test square_system()
    def test_FixedpointNewton_Question1_Subquestion2(self):
        val1 = module.square_system()
        ref1 = [ 1.51154714, -0.71522524]
        tol1 = 1.0e-4

        message = "Root too far from reference value. See unittest/moduletest.py for details. received: %f reference: %f correct number of decimals required: %f"

        self.assertTrue(near_array(val1, ref1, tol1))

    # Test solve(..., "fixedpoint")
    def test_Solve_Question2_Subquestion1(self):
        def f_exp(t, u):
            return -u

        # Solve f_exp with timestep close to limit given by contraction
        # mapping.
        I = [0.0, 3.8]
        k = 1.9
        u0 = 1.0
        [tarray, uarray] = module.solve(f_exp, I, u0, k,
                                        "Midpoint", "fixedpoint")

        val1 = uarray[0, -1]
        ref1 = 0.000657466752628
        tol1 = 1.0e-6

        message = "Root too far from reference value. See unittest/moduletest.py for details. received: %f reference: %f correct number of decimals required: %f"

        self.assertTrue(near(val1, ref1, tol1))

    # Test solve(..., "newton")
    def test_Solve_Question2_Subquestion2(self):
        def f_exp(t, u):
            return -u

        # Solve f_exp with Newton's method allowing an arbitrarily large
        # timestep
        I = [0.0, 40.0]
        k = 4.0
        u0 = 1.0
        [tarray, uarray] = module.solve(f_exp, I, u0, k,
                                        "Midpoint", "newton")

        val1 = uarray[0, -1]
        ref1 = 1.69350878084e-05
        tol1 = 1.0e-6

        message = "Root too far from reference value. See unittest/moduletest.py for details. received: %f reference: %f correct number of decimals required: %f"

        self.assertTrue(near(val1, ref1, tol1))


    # Test Jacobi
    def test_Solve_Question3(self):

        A = array([[70, 1, 5], [3, 80, 4], [6, 2, 90]], 'd')
        b = array([2, 4, 6])

        x = module.jacobi(A, b)

        val1 = x
        ref1 = array([ 0.02333754,  0.04592032,  0.06409038])
        tol1 = 1.0e-4

        message = "Root too far from reference value. See unittest/moduletest.py for details. received: %f reference: %f correct number of decimals required: %f"

        self.assertTrue(near_array(val1, ref1, tol1))

unittest.main()
